Unit Av19e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTAV11_p;

procedure Av19e(N :Integer; var SX :Array of Extended; INCX :Integer;
                var SY :Array of Extended; INCY :Integer; C :Extended;
                S :Extended; var IERR :Integer);
implementation

procedure Av19e(N :Integer; var SX :Array of Extended; INCX :Integer;
                var SY :Array of Extended; INCY :Integer; C :Extended;
                S :Extended; var IERR :Integer);
var                
I,IX,IY :Integer;
STEMP,X :Extended;
label
_10,_20,_30,_40,_60;
begin

{       }

X := 0.0e0;

{       N }
if ( N <= 0 ) 
 then goto _40;
IERR := 0;
if ( C = 1.0e0) and (S = 0.0e0 ) 
 then goto _60;
if ( INCX = 1) and (INCY = 1 ) 
 then goto _20;
IX := Trunc( 1 + ((INCX - Abs(INCX))/2)*(1 - N) );
IY := Trunc( 1 + ((INCY - Abs(INCY))/2)*(1 - N) );
for I:=1 to N do
 begin
  STEMP := C*SX[IX-1] + S*SY[IY-1];
  SY[IY-1] := C*SY[IY-1] - S*SX[IX-1];
  SX[IX-1] := STEMP;
  IX := IX + INCX;
  IY := IY + INCY;
_10:
 end;
goto _60;
_20:
for I:=1 to N do
 begin
  STEMP := C*SX[I-1] + S*SY[I-1];
  SY[I-1] := C*SY[I-1] - S*SX[I-1];
  SX[I-1] := STEMP;
_30:
 end;
goto _60;
_40:
IERR := 65;
UTAV11(IERR,28);
goto _60;
_60:
end;

end.
